clear
%Jie Ma Matlab final pro
%preditor and prey model using given preditor
%one preditor(fox) and two Prey (rabbit)

%Function in the system: Lotka-Volterra Equation
%dxdt = (-d+ey+etz)*x, dydt = (kr(m-y)-cx)*y, dzdt =(kt(mt-z)-ctx)z

%define global variabe b d e c
global d e et kr m c kt mt ct
d = 0.5;
e = 0.01;
et = 0.02;
kr = 0.01;
m = 100;
c = 0.02;
kt = 0.04;
mt = 80;
ct = 0.01;

% the Stedy state is when the initial population x0 = 50, y0 = 50;
xx0 = 100;
yy0 = 90;
zz0 = 40;
y = [xx0; yy0;zz0]; 
%calculate dt using 200 time step
n = 1000;
t = 0;

dt = 0.01;
tt = zeros(n+1,1);
Yt = zeros(n+1,size(y,1));
tt(1)   = t;
Yt(1,:) = y';
totPoP = zeros(n+1,1);

for i=1:n

    f1 = lotka3(t     , y                );
    f2 = lotka3(t+dt/2, y+f1 .*  (dt/2)  );
    f3 = lotka3(t+dt/2, y+f2 .*  (dt/2)  );
    f4 = lotka3(t+dt  , y+f3 .*   dt     );
   
    y = y + (f1 + f2.*2 + f3.*2 + f4) .* (dt/6);
    
    t = t+dt;
    tt(i+1)   = t;  % this records the time at each step
    Yt(i+1,:) = y';% this records the vector Y at each step --> Yt(:,1) has all x coordinates
    totPoP (i)= Yt(i,1)+Yt(i,2)+Yt(i,3);   
end
%shows a cicle for the popu
 plot(Yt(:,1),Yt(:,2))
ylabel('rabbits')
xlabel('fox')
pause
 plot(tt,Yt(:,1),'r' ,tt,Yt(:,2),'g', tt, Yt(:,3),'b', 'LineWidth',4)
xlabel('time')
ylabel('population')
pause 
%show the total population
 plot(tt,totPoP(:,1));
pause
.................................................

%vaisulation through making square


maxPoP = max(totPoP)
sn = round (sqrt(maxPoP+1));
total_squar = sn*sn;
A = zeros(sn+2,sn+2,3,'uint8');

%give a gray background
%give the red color to the predtor
%single time step
count = 0;

 
for i = 1:300
    
    if(mod(i,10)==0)
       A (:,:,1) = 128;
       A (:,:,2) = 138;
       A (:,:,3) = 135;
        numbird = Yt(i,1);
        numwhite = Yt(i,2);
        numblack = Yt(i,3);

        %the bird color should be red, no bird being showed
%         for j = 1:numbird
%             %calculte the index of the location
%             while 1
%             randloc = round(rand()*maxPoP); 
%             rand_row = round(mod(randloc,sn))+1;
%             rand_col = round(randloc/sn)+1;
%             %if the poistion has already be not been taken, reject to move
%             if(A(rand_row,rand_col,2) == 192)
% 
%                A(rand_row,rand_col,1) = 255;
%                A(rand_row,rand_col,2) = 0;
%                A(rand_row,rand_col,3) = 0;   
%               break   
%             end
%             end
% 
%         end
        
        %the white color shuold be white moth
         for k = 1:numwhite
        %     %calculte the index of the location
             while 1
             randloc = round(rand()*maxPoP); 
             rand_row = round(mod(randloc,sn))+1;
             rand_col = round(randloc/sn)+1;
            %if the poistion has already be not been taken, reject to move
            if(A(rand_row,rand_col,2) == 138)

               A(rand_row,rand_col,1) = 255;
               A(rand_row,rand_col,2) = 255;
               A(rand_row,rand_col,3) = 0;   
              break   
            end
            end
        % 
         end
         %the black moth should be the black moth
         
         for k = 1:numblack
        %     %calculte the index of the location
             while 1
             randloc = round(rand()*maxPoP); 
             rand_row = round(mod(randloc,sn))+1;
             rand_col = round(randloc/sn)+1;
            %if the poistion has already be not been taken, reject to move
            if(A(rand_row,rand_col,2) == 138)

               A(rand_row,rand_col,1) = 41;
               A(rand_row,rand_col,2) = 36;
               A(rand_row,rand_col,3) = 33;   
              break   
            end
            end
        % 
         end
         pause(0.2)
         
         
         imshow(A)
         
         saveas(gcf,['peppered moth_',sprintf('%03d',count),'.png'])
         A
         count = count +1
   end
   
end
%}