clear
%Jie Ma Matlab final pro
%preditor and prey model using given preditor
%one preditor(fox) and one Prey (rabbit)

%Function in the system: Lotka-Volterra Equation
%dxdt = (-d+ey)x; dydt = (b-cx)y

%define global variabe b d e c
global d e b c
d = 0.5;
e = 0.001;
b = 0.5;
c = 0.001;
% the Stedy state is when the initial population x0 = 50, y0 = 50;
xx0 = 800;
yy0 = 1000;

y = [xx0; yy0]; 
%calculate dt using 200 time step
n = 5000;
t = 0;

dt = 0.01;
tt = zeros(n+1,1);
Yt = zeros(n+1,size(y,1));
tt(1)   = t;
Yt(1,:) = y';
totPoP = zeros(n+1,1);

for i=1:n

    f1 = lotka2(t     , y                );
    f2 = lotka2(t+dt/2, y+f1 .*  (dt/2)  );
    f3 = lotka2(t+dt/2, y+f2 .*  (dt/2)  );
    f4 = lotka2(t+dt  , y+f3 .*   dt     );
   
    y = y + (f1 + f2.*2 + f3.*2 + f4) .* (dt/6);
    
    t = t+dt;
    tt(i+1)   = t;  % this records the time at each step
    Yt(i+1,:) = y';% this records the vector Y at each step --> Yt(:,1) has all x coordinates
    totPoP (i)= Yt(i,1)+Yt(i,2);   
%     plot(tt,Yt(i,1),'r',tt,Yt(i,2),'g','LineWidth',4)
%     hold on 
end

%shows a cicle for the popu
 plot(Yt(:,1),Yt(:,2),'LineWidth',3)
 ylabel('rabbits')
 xlabel('fox')
 pause
plot(tt,Yt(:,1),'r',tt,Yt(:,2),'b','LineWidth',4)
xlabel('time')
ylabel('rabbits and fox')
pause 
% %show the total population
% plot(tt,totPoP(:,1));
% pause
.................................................
.....................................
%vaisulation through making square



maxPoP = max(totPoP)
sn = round (sqrt(maxPoP+1));
total_squar = sn*sn;
A = zeros(sn,sn,3,'uint8');
A (:,:) = 255;
%give the red color to the predtor
%single time step
count = 0;

 
for i = 1:n
    
   if(mod(i,50)==0)
        
       A (:,:) = 255;
        numFox = Yt(i,1);
        numRabit = Yt(i,2);


        for j = 1:numFox
            %calculte the index of the location
            while 1
            randloc = round(rand()*maxPoP); 
            rand_row = round(mod(randloc,sn))+1;
            rand_col = round(randloc/sn)+1;
            %if the poistion has already be not been taken, reject to move
            if(A(rand_row,rand_col,2) == 255)

               A(rand_row,rand_col,1) = 255;
               A(rand_row,rand_col,2) = 0;
               A(rand_row,rand_col,3) = 0;   
              break   
            end
            end

        end

         for k = 1:numRabit
        %     %calculte the index of the location
             while 1
             randloc = round(rand()*maxPoP); 
             rand_row = round(mod(randloc,sn))+1;
             rand_col = round(randloc/sn)+1;
            %if the poistion has already be not been taken, reject to move
            if(A(rand_row,rand_col,2) == 255)

               A(rand_row,rand_col,1) = 0;
               A(rand_row,rand_col,2) = 0;
               A(rand_row,rand_col,3) = 255;   
              break   
            end
            end
        % 
         end
         imshow(A)
        
         
         saveas(gcf,['population_',sprintf('%03d',count),'.png'])
         A
         count = count +1
   end
   
end